//Board.h//

#ifndef __BOARD_H
#define __BOARD_H

#include <string>
//using namespace std

#include "Cell.h"

/** @brief the game board
 *
 * This class models the game board of snakes and ladders
 */
class Board
{
  public:
    /// number of cells in the board
    static int const NCELLS = 100;

    /// construct from a file
    Board(const string& rkoStrFileN="");

    /// save to a file
    void Save(const string& rkoStrFileN) const;

    /// add a portal to the board
    void AddPortal(int iSPos, int iEPos);

    /// delete a portal from the board
    void DelPortal(int iSPos);

    /// walk some moves from the start position, return the end position
    int Walk(int iSPos, int iMoves);

    /// warp to some position, return the end position
    int Warp(int iPos);

    /// get the nth cell in the board
    const Cell& operator[] (int iPos);
    
  private:
    /// the cells in the board
    Cell m_oCell[NCELLS];

    /// the filename of this board
    string m_oStrFileN;
};

#endif //__BOARD_H

//Board.h//
