// BoardFactory.h //

#ifndef __BOARDFACTORY_H
#define __BOARDFACTORY_H

#include <vector>
#include <string>
#include "Board.h"

class BoardFactory
{
  public:
    static BoardFactory *Instance(void);
    Board *LoadBoard(const string& rkoStrName);
    void SaveBoard(const Board *pkoBoard, const string& rkoStrName);
    const vector< string >& List(void);
    void ReadList(void);
    void ScanDir (const string& rkoStrDirName);
    void Delete (const string& rkoStrName);

  protected:
    BoardFactory(void);
    ~BoardFactory(void);
    
  private:
    static BoardFactory *c_poInstance;
    vector< string > m_oVecStrBoardMap;
};

#endif //__BOARDFACTORY_H

// BoardFactory.h //
