#include "EntryWidget.h"

EntryWidget::EntryWidget(int iYPos, int iXPos, int iXSize
    , const string& rkoStrLabel)
: Widget (3, iXSize+2, iYPos, iXPos, true)
{
  keypad(m_poWin, true);
  m_oStrLabel = rkoStrLabel;
  m_oStrValue = "";
  m_iCurrPos = 0;
  m_iXSize = iXSize;
}

void EntryWidget::Draw (void)
{
  DrawEntry();
}

int EntryWidget::KeyFocus (void)
{
  Render();
  do
  {
    int iCh = GetCh(0, m_oStrLabel.size());

    switch (iCh)
    {
      case 10:
        return iCh;
        break;

      case 'a'...'z':
      case 'A'...'Z':
      case '0'...'9':
      case '.':
      case '_':
        if (m_oStrValue.size() < m_iXSize - m_oStrLabel.length() -4)
        {
          m_oStrValue += iCh;
          m_iCurrPos++;
          Render();
        }
        else
        {
          beep();
        }
        break;

      case KEY_BACKSPACE:
        m_oStrValue = "";
        m_iCurrPos=0;
        Draw();
        Refresh();
        break;

      default:
        break;
    }
  }
  while (true);
}

const string& EntryWidget::GetValue (void)
{
  return m_oStrValue;
}

void EntryWidget::DrawEntry (void)
{
  string oStr= m_oStrLabel + ": " + m_oStrValue;
  while (oStr.size() < m_iXSize)
  {
    oStr += ' ';
  }
  wattron(m_poWin, WA_BOLD);
  AddStr(0,0, oStr);
  wattroff(m_poWin, WA_BOLD);
}
